#ifndef _PCIE9759B_DEVICE_
#define _PCIE9759B_DEVICE_

#define PCIE9759B_AD_MAX_CHANNELS		4	// ֧4·ģͨ
//#################### ADӲPCIE9759B_PARA_AD #####################
// ADʵӲ
typedef struct _PCIE9759B_PARA_AD     
{
	LONG bChannelArray[4];	// ͨѡУֱ4ͨ=1ʾͨ=0
	LONG InputRange[4];		// ģѡУֱ4ͨ
	LONG RefGround[4];		// زοʽ
	LONG Frequency;         // ɼƵ, λΪHz, ߲5MHz
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerType;		// ѡ
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TriggerSource;		// Դѡ
	LONG TrigLevelVolt;		// ƽ(-10V~10V)
	LONG TrigWindow;		// , λ25
	LONG RefClkSrc;			// οʱԴѡ
	LONG CnvClkSrc;			// תʱԴѡ
	LONG bClockOutput;		// תʱCLKOUT, =TRUE:, =FALSE:ֹ
	LONG SyncTrigSrc;		// ͬԴѡ
	LONG bMasterEn;			// 豸ʹ  
							// =0豸ͨTriggerźŽ豸͵ͬź
							// =1豸ͨTriggerźΪ豸Ĵź
							// עڶģͬϵͳУֻ趨һ豸Ϊ豸趨Ϊ豸ϵͳֻһ豸ж豸ǲҪͬ轫豸趨Ϊ豸
} PCIE9759B_PARA_AD, *PPCIE9759B_PARA_AD;

//***********************************************************
// ADPCIE9759B_PARA_ADеInputRange[X]ʹõӲѡ
const long PCIE9759B_INPUT_N5000_P5000mV			= 0x00; // 5000mV
const long PCIE9759B_INPUT_N2500_P2500mV			= 0x01; // 2500mV
const long PCIE9759B_INPUT_N1250_P1250mV			= 0x02; // 1250mV
const long PCIE9759B_INPUT_N625_P625mV				= 0x03; // 625mV

//***********************************************************
// ADӲPCIE9759B_PARA_ADеRefGroundģʽʹõѡ
const long PCIE9759B_REFGND_RSE						= 0x00; // 
const long PCIE9759B_REFGND_DIFF					= 0x01; // 

//***********************************************************
// ADӲPCIE9759B_PARA_ADеTriggerModeģʽʹõѡ
const long PCIE9759B_TRIGMODE_SOFT					= 0x00; // 
const long PCIE9759B_TRIGMODE_POST					= 0x01; // Ӳ

// ADӲPCIE9759B_PARA_ADеTriggerTypeʹõѡ
const long PCIE9759B_TRIGTYPE_EDGE					= 0x00; // ش
const long PCIE9759B_TRIGTYPE_PULSE					= 0x01; // 崥(ƽ)

//***********************************************************
// ADӲPCIE9759B_PARA_ADеTriggerDirʹõѡ
const long PCIE9759B_TRIGDIR_NEGATIVE				= 0x00; // 򴥷(/½ش)
const long PCIE9759B_TRIGDIR_POSITIVE				= 0x01; // 򴥷(/ش)
const long PCIE9759B_TRIGDIR_POSIT_NEGAT			= 0x02; // 򴥷(//½ش)

//***********************************************************
// ADӲPCIE9759B_PARA_ADеTriggerSourceԴźʹõѡ
const long PCIE9759B_TRIGSRC_DTR					= 0x00; // ѡDTRΪԴ
const long PCIE9759B_TRIGSRC_ATR					= 0x01; // ѡATRΪԴ
const long PCIE9759B_TRIGSRC_TRIG					= 0x02; // TriggerźŴڶ࿨ͬ

//***********************************************************
// ADӲPCIE9759B_PARA_ADеRefClkSrcοʱԴʹõѡ
const long PCIE9759B_REFCLKSRC_IN					= 0x00; // ʹڲοʱ
const long PCIE9759B_REFCLKSRC_10M					= 0x01; // ʹ10Mʱ

//***********************************************************
// ADӲPCIE9759B_PARA_ADеCnvClkSrcתʱԴʹõѡ
const long PCIE9759B_CNVCLKSRC_IN					= 0x00; // ʹڲתʱ
const long PCIE9759B_CNVCLKSRC_EXT					= 0x01; // ʹⲿתʱ,EXT_CLKܽ

//***********************************************************
// ADӲPCIE9759B_PARA_ADеSyncTrigSrcͬԴʹõѡ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER0					= 0x00; // ѡͬTRIG0źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER1					= 0x01; // ѡͬTRIG1źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER2					= 0x02; // ѡͬTRIG2źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER3					= 0x03; // ѡͬTRIG3źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER4					= 0x04; // ѡͬTRIG4źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER5					= 0x05; // ѡͬTRIG5źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER6					= 0x06; // ѡͬTRIG6źŴ
const long PCIE9759B_SYNCTRIGSRC_TRIGGER7					= 0x07; // ѡͬTRIG7źŴ


//*************************************************************************************
// ADʵӲ
typedef struct _PCIE9759B_STATUS_AD     
{
	LONG bNotEmpty;			// FIFO洢ķǿձ־=TRUEǿգ = FALSE 
	LONG bHalf;				// FIFO洢İ־=TRUEϣ = FALSE 
	LONG bDynamic_Overflow; // FIFO洢Ķ̬־= TRUEѷ = FALSEδ
	LONG bStatic_Overflow;  // FIFO洢ľ̬־= TRUEѷ = FALSEδ
} PCIE9759B_STATUS_AD, *PPCIE9759B_STATUS_AD;

//***********************************************************
// ûӿ
#ifndef _PCIE9759B_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## 豸 ##############################
	HANDLE DEVAPI FAR PASCAL PCIE9759B_CreateDevice(int DeviceLgcID = 0);     // ߼Ŵ豸
	int DEVAPI FAR PASCAL PCIE9759B_GetDeviceCount(HANDLE hDevice); // ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCIE9759B_GetDeviceCurrentID(HANDLE hDevice,		// ȡõǰ豸ӦID
													PLONG DeviceLgcID, 
													PLONG DevicePhysID);
	BOOL DEVAPI FAR PASCAL PCIE9759B_ListDeviceDlg(HANDLE hDevice); // ԶԻ巽ʽбϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PCIE9759B_ReleaseDevice(HANDLE hDevice); // ͷ豸

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ
	BOOL DEVAPI FAR PASCAL PCIE9759B_ADCalibration(			// 豸У׼.		
									HANDLE hDevice);		// 豸

	BOOL DEVAPI FAR PASCAL PCIE9759B_InitDeviceAD(		// ʼ豸TRUE,豸׼.
									HANDLE hDevice,			// 豸,CreateDevice
									PPCIE9759B_PARA_AD pADPara); // Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCIE9759B_StartDeviceAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9759B_ReadDeviceAD(	// ô˺ȡ豸ϵAD
									HANDLE hDevice,			// 豸,CreateDevice
									USHORT ADBuffer[],      // ڽԭʼADݵû								
									ULONG nSizePoints,		// ȡݵ
									PULONG pRetPoints,		// ʵʶȡ, =NULL,ʾ뷵
									PULONG pAvailSampsPoints,	// ʣ, =NULL,ʾ뷵
									double fTimeout);			// ʱʱ䵥λ:(S)
		
    BOOL DEVAPI FAR PASCAL PCIE9759B_StopDeviceAD(		// 豸֮ͣ豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9759B_ReleaseDeviceAD(		// رAD豸,ֹ,ͷԴ
									HANDLE hDevice);		// 豸,CreateDevice


	//##################### ADӲ ###########################
	BOOL DEVAPI FAR PASCAL PCIE9759B_SaveParaAD(HANDLE hDevice, PPCIE9759B_PARA_AD pADPara); // ǰADϵͳ
    BOOL DEVAPI FAR PASCAL PCIE9759B_LoadParaAD(HANDLE hDevice, PPCIE9759B_PARA_AD pADPara); // ADϵͳж
    BOOL DEVAPI FAR PASCAL PCIE9759B_ResetParaAD(HANDLE hDevice, PPCIE9759B_PARA_AD pADPara); // ADָĬֵ

	//####################### I/O #################################
	// ûʹWriteRegisterULongReadRegisterULongȺֱӿƼĴI/O
	// ʹʡ£ҪļĴλȣֻ
	// VBԵԲô򵥵ʵָͨĿơ

	// ############################ DIOʵֺ ############################
	BOOL DEVAPI FAR PASCAL PCIE9759B_SetDir(			// ˿ڸͨ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG bLineDirArray[16]);	// ߷򻺳, ˿иߵķbLineDirArray[n]=0:ʾ, =1ʾ

	BOOL DEVAPI FAR PASCAL PCIE9759B_GetDir(			// ض˿ڸͨ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG bLineDirArray[16]);	// ߷򻺳, ض˿иߵķbLineDirArray[n]=0:ʾ, =1ʾ

	BOOL DEVAPI FAR PASCAL PCIE9759B_ReadPort(			// ˿ֵ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG* pPortData);	// صĶ˿, ЧλBit[15:0], ÿһλһֵֵ򿪹ضֵ

	BOOL DEVAPI FAR PASCAL PCIE9759B_WritePort(			// д˿ֵ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG nPortData);	// ˿, ЧλBit[15:0]ÿһλһֵ߷ΪʱдλֵЧ,Ϊʱ=0:ʾ()״̬, =1ʾ()״̬

	BOOL DEVAPI FAR PASCAL PCIE9759B_ReadLines(			// ˿ڶֵ(Read Mult Lines Data from the DI Port)
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG bLineDataArray[16]);// ݻ, ÿһԪشһֵֵ򿪹ضֵ=0:ʾ()״̬, =1ʾ()״̬

	BOOL DEVAPI FAR PASCAL PCIE9759B_WriteLines(		// д˿ֵ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG bLineDataArray[16]); // ݻ, ÿһԪشһֵ,߷ΪʱдλֵЧ,Ϊʱ=0:ʾ()״̬, =1ʾ()״̬

	BOOL DEVAPI FAR PASCAL PCIE9759B_ReadLine(			// ֵ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG nLine,		// ߺ[0, 15]
									ULONG* pLineData);	// , ȡֵ01 

	BOOL DEVAPI FAR PASCAL PCIE9759B_WriteLine(			// дֵ
									HANDLE hDevice,		// 豸,CreateDevice
									ULONG nLine,		// ߺ[0, 15]
									ULONG bLineData);	// ֵ,ȡֵ01

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCIE9759B_GetDeviceBar(			// ȡָָ豸ĴBARַ
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵

	BOOL DEVAPI FAR PASCAL PCIE9759B_GetDevVersion(			// ȡ豸̼汾
									HANDLE hDevice,			// 豸,CreateDevice
									PULONG pulFmwVersion,	// ̼汾
									PULONG pulDriverVersion);// 汾

    BOOL DEVAPI FAR PASCAL PCIE9759B_WriteRegisterByte(		// ָĴռλд뵥
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbLinearAddr,		// ָĴԻַ,GetDeviceAddrеpbLinearAddrֵ
									ULONG OffsetBytes,		// Իַַƫλ(ֽ)
									BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PCIE9759B_WriteRegisterWord(		// д˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									WORD Value);

	BOOL DEVAPI FAR PASCAL PCIE9759B_WriteRegisterULong(		// дĽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									ULONG Value);

	BYTE DEVAPI FAR PASCAL PCIE9759B_ReadRegisterByte(		// 뵥ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PCIE9759B_ReadRegisterWord(		// ˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PCIE9759B_ReadRegisterULong(		// ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
    BOOL DEVAPI FAR PASCAL PCIE9759B_WritePortByte(			// 8λд˿
									HANDLE hDevice,			// 豸(CreateDevice)
									__int64 pPort,				// ˿ڵַ
									BYTE Value);			// д8λ

    BOOL DEVAPI FAR PASCAL PCIE9759B_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
    BOOL DEVAPI FAR PASCAL PCIE9759B_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

    BYTE DEVAPI FAR PASCAL PCIE9759B_ReadPortByte(HANDLE hDevice, __int64 pPort);
    WORD DEVAPI FAR PASCAL PCIE9759B_ReadPortWord(HANDLE hDevice, __int64 pPort);
    ULONG DEVAPI FAR PASCAL PCIE9759B_ReadPortULong(HANDLE hDevice, __int64 pPort);
	// Ҫûģʽ£ֱӷӲ˿ڣ밲װʹISA\CommUserµReadPortByteExȺ

	//########################### Ӳ ######################################
	HANDLE DEVAPI FAR PASCAL PCIE9759B_CreateSystemEvent(void); // ں¼󣬹InitDeviceDmaADVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCIE9759B_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

//***********************************************************
// FIFO洢ĳ()
const long FIFO_IDT7202_LENGTH			= 1024;
const long FIFO_IDT7203_LENGTH			= 2048;
const long FIFO_IDT7204_LENGTH			= 4096;
const long FIFO_IDT7205_LENGTH			= 8192;
const long FIFO_IDT7206_LENGTH			= 16384;
const long FIFO_IDT7207_LENGTH			= 32768;

// Զ
#ifndef _PCIE9759B_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PCIE9759B_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9759B_32.dll...")
		#pragma message("======== Successfully linked with PCIE9759B_32.dll")
	#else
		#pragma comment(lib, "PCIE9759B_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9759B_64.dll...")
		#pragma message("======== Successfully linked with PCIE9759B_64.dll")
	#endif
#endif

#endif // _PCIE9759B_DEVICE_